/*
    This program uses a (binary) semaphore to avoid the
    race condition.
*/
#include <windows.h>
#include <stdio.h>

// global variables
int runFlag = TRUE;
unsigned int count  = 0;  // this variable is shared by thread1 and thread2
unsigned int count1 = 0;  // this variable is used only by thread1
unsigned int count2 = 0;  // this variable is used only by thread2

HANDLE semaphore;

int main( int argc, char *argv[])
{
   DWORD WINAPI thread1(LPVOID);  //thread function prototypes
   DWORD WINAPI thread2(LPVOID);

   int threadParam1 = 0;  // thread function parameter
   int threadParam2 = 0;

   // create a (binary) Semaphore object
   semaphore = CreateSemaphore(NULL, 1, 1, NULL); // signaled

   // create threads
   printf("race2s: Starting threads\n");
   CreateThread(NULL, 0, thread1, &threadParam1, 0, NULL);
   CreateThread(NULL, 0, thread2, &threadParam2, 0, NULL);

   // let the threads run for a while
   Sleep(2000);
   // now stop the threads
   runFlag = FALSE;
   Sleep(20);

   printf("\nThreads stopped.\n");
   printf("count = %d, count1 = %d, count2 = %d\n", count, count1, count2);

   return 0;
}//main


DWORD WINAPI thread1(LPVOID threadParam)
{
      unsigned int new_count, old_count;
      while(runFlag)
      {
         WaitForSingleObject(semaphore, INFINITE);
         old_count = count++;
         new_count = count;
         ReleaseSemaphore(semaphore, 1, NULL);

         if (new_count - old_count != 1)
            printf("Bingo1: new_count - old_count = %d\n", new_count-old_count);
         count1++;
   }
   return 0;
}//thread1


DWORD WINAPI thread2(LPVOID threadParam)
{
   unsigned int new_count, old_count;
   while(runFlag)
   {
      WaitForSingleObject(semaphore, INFINITE);
      old_count = count++;
      new_count = count;
      ReleaseSemaphore(semaphore, 1, NULL);

      if (new_count - old_count != 1)
         printf("Bingo2: new_count - old_count = %d\n", new_count-old_count);
      count2++;
   }
   return 0;
}//thread2
